<template>
  <div>
    <q-list
      v-if="observations && observations.length"
      separator
    >
      <q-item
        v-for="observation in observations"
        :key="observation.id"
        clickable
        v-ripple
        @click="onEditObservation(observation)"
      >
        <q-item-section
          side
        >
          <q-icon
            name="las la-ruler"
          />
        </q-item-section>

        <q-item-section class="text-body2">
          <q-item-label lines="1">
            {{ displayObservationLabel(observation.observableProperty) }}
          </q-item-label>
          <q-item-label
            lines="1"
            caption
          >
            {{ displayObservationValue(observation) }}
          </q-item-label>
        </q-item-section>

        <q-item-section
          side
          top
        >
          <q-icon
            name="las la-angle-right"
            class="q-mt-auto q-mb-auto"
          />
        </q-item-section>
      </q-item>
    </q-list>

    <q-card-section
      v-else
      class="text-body2 text-grey"
    >
      <translate>Add soil analysis to the sample.</translate>
    </q-card-section>

    <q-card-actions
      align="right"
    >
      <q-btn
        outline
        color="primary"
        @click="onNewObservation"
        class="q-mr-sm q-mb-sm"
      >
        <translate>
          Add analysis
        </translate>
      </q-btn>
    </q-card-actions>

    <q-dialog
      v-model="openEditDialog"
      persistent
      ref="observationEditDialog"
    >
      <ObservationEditForm
        :id="editedObservationId"
        :initial-observable-property="editedObservationObservableProperty"
        :initial-value="editedObservationValue"
        :existing-observations="observations"
        @on-save="onSaveObservation"
        @on-delete="onDeleteObservation"
        @on-cancel="onCancelObservation"
      />
    </q-dialog>
  </div>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import ObservationEditForm from 'src/pages/holding-campaign/soil-site/components/ObservationEditForm'
import { getI18nField } from 'src/services/translate'

export default {
  name: 'ObservationsCard',
  mixins: [
    PlatformMixin
  ],
  components: {
    ObservationEditForm
  },
  props: {
    initialObservations: {
      type: Array,
      required: true
    }
  },
  emits: ['on-update'],
  data () {
    return {
      observations: this.initialObservations,
      openEditDialog: false,
      editedObservation: null
    }
  },
  computed: {
    editedObservationId () {
      return this.editedObservation?.id
    },
    editedObservationObservableProperty () {
      if (this.editedObservation?.observableProperty) {
        return {
          ...this.editedObservation?.observableProperty,
          labelI18n: getI18nField(this.editedObservation?.observableProperty, 'label')
        }
      } else {
        return null
      }
    },
    editedObservationValue () {
      return String(this.getObservationValue(this.editedObservation))
    }
  },
  methods: {
    onEditObservation (observation) {
      this.editedObservation = observation
      this.openEditDialog = true
    },
    onNewObservation () {
      this.openEditDialog = true
    },
    onSaveObservation (observation) {
      if (observation.id) {
        this.onUpdateObservation(observation)
      } else {
        this.onCreateObservation(observation)
      }
    },
    onCreateObservation (observation) {
      // add a temporary id to allow edition in the list before saving it
      this.observations.push({ ...observation, id: new Date().getTime() })
      this.openEditDialog = false
      this.editedObservation = null
      this.$emit('on-update', this.observations)
    },
    onUpdateObservation (observation) {
      for (let i = 0; i < this.observations.length; i++) {
        if (this.observations[i].id === observation.id) {
          this.observations.splice(i, 1, observation)
          break
        }
      }
      this.openEditDialog = false
      this.editedObservation = null
      this.$emit('on-update', this.observations)
    },
    onDeleteObservation (observationId) {
      for (let i = 0; i < this.observations.length; i++) {
        if (this.observations[i].id === observationId) {
          this.observations.splice(i, 1)
          break
        }
      }
      this.openEditDialog = false
      this.editedObservation = null
      this.$emit('on-update', this.observations)
    },
    onCancelObservation () {
      this.openEditDialog = false
      this.editedObservation = null
    },
    getObservationValue (observation) {
      return observation?.result?.value || ''
    },
    displayObservationValue (observation) {
      if (observation?.result?.label) {
        return observation.result.label.trim()
      } else if (typeof observation?.result?.value === 'number') {
        let formatted = observation.result.value.toFixed(1)
        if (observation.observableProperty.unitOfMeasure.id !== 'no_unit') {
          formatted += ' ' + getI18nField(observation.observableProperty.unitOfMeasure, 'symbol')
        }
        return formatted
      } else if (typeof observation?.result?.value === 'boolean') {
        return observation.result.value ? this.$gettext('Yes') : this.$gettext('No')
      } else if (typeof observation?.result?.value === 'string') {
        return observation.result.value.trim()
      }
    },
    displayObservationLabel (observableProperty) {
      return getI18nField(observableProperty, 'label')
    }
  }
}

</script>
